#include "node.h"
#include <math.h>
double Node::contactScale;

double Node::getWeightedMean() {
  double wp(0);
  for (int i=1; i<probabilities.size(); i++) {
    wp+=(double)i*exp(probabilities[i]);
  }
  return wp;
}

double Node::probability() {
  // Experiment: We want more constraints than constacts, so we use scaling
  double numN = (double)numNeighbours*contactScale;
  int fl = (int)floor(numN);

  if (fl > 13)
    fl = 13;

  double p_fl = probabilities[fl];

  int cl = fl+1;
  if (fl==13)
    cl = 13;

  double p_ceil = probabilities[cl];
  
  return p_fl + (numN-fl)*(p_ceil-p_fl);
}
