#include "constraint.h"
#include "node.h"
#include <map.h>

class Problem {
 public:
  vector<Node> nodes;
  vector<Constraint> constraints;
  vector<Constraint> noncontacts;
  vector<int> residue2nodeindex;
  vector<double> SepProb;
  vector<int> sepCount;
  vector<int> TotalPairs;
  map<int, int> atom2residue;
  double score;
  double weightSum;
  double avgSum;
  double probValue;
  double perc;
  double desiredProb;
  double probSep;
  int NConstraints;
  bool JustHighestWeight;
  bool JustRandom;

  //  double GetBestLoopScore(Node & n, double apply, vector<pair< int, Constraint* > > visited, int N, double score);
  void updateScore(Constraint & cst, bool insert);
  void readProbabilities(char* str);
  void readConstraints(char* str);
  void readSeperation(char* str);
  void Optimize();
  bool Opt();
  bool Opt2();
  void buildInitialSolution();
  void Scaling();
  void writeOutput(char* str);
  double scoreFromScratch(bool output=false);
  double probSepFromScratch();
  double updateProbSep(int i, bool insert);
  double Poisson(double expected, int real);
};

